VTK: vtkVoidArray Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkVoidArray Class Reference

dynamic, self-adjusting array of void* pointers More...

`#include <vtkVoidArray.h>`

Inheritance diagram for vtkVoidArray:
[legend]
Collaboration diagram for vtkVoidArray:
[legend]

## Public Types
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkVoidArray * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
vtkTypeBool | Allocate (vtkIdType sz, vtkIdType ext=1000)
| Allocate memory for this array. More...
void | Initialize ()
| Release storage and reset array to initial state. More...
int | GetDataType () const
| Return the type of data. More...
int | GetDataTypeSize ()
| Return the size of the data contained in the array. More...
void | SetNumberOfPointers (vtkIdType number)
| Set the number of void* pointers held in the array. More...
vtkIdType | GetNumberOfPointers ()
| Get the number of void* pointers held in the array. More...
void * | GetVoidPointer (vtkIdType id)
| Get the void* pointer at the ith location. More...
void | SetVoidPointer (vtkIdType id, void *ptr)
| Set the void* pointer value at the ith location in the array. More...
void | InsertVoidPointer (vtkIdType i, void *ptr)
| Insert (memory allocation performed) the void* into the ith location in the array. More...
vtkIdType | InsertNextVoidPointer (void *tuple)
| Insert (memory allocation performed) the void* pointer at the end of the array. More...
void | Reset ()
| Reuse already allocated data; make the container look like it is empty. More...
void | Squeeze ()
| Resize the array to just fit the inserted memory. More...
void ** | GetPointer (vtkIdType id)
| Get the address of a particular data index. More...
void ** | WritePointer (vtkIdType id, vtkIdType number)
| Get the address of a particular data index. More...
void | DeepCopy (vtkVoidArray *va)
| Deep copy of another void array. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkVoidArray * | New ()
| Initialize with empty array. More...
static vtkVoidArray * | ExtendedNew ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkVoidArray * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkVoidArray ()
| ~vtkVoidArray () override
void ** | ResizeAndExtend (vtkIdType sz)
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
vtkIdType | NumberOfPointers
vtkIdType | Size
void ** | Array
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

dynamic, self-adjusting array of void* pointers

vtkVoidArray is an array of pointers to void. It provides methods for insertion and retrieval of these pointers values, and will automatically resize itself to hold new data.

Definition at line 19 of file vtkVoidArray.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkObject vtkVoidArray::Superclass

Definition at line 28 of file vtkVoidArray.h.

## Constructor & Destructor Documentation

## ◆ vtkVoidArray()

vtkVoidArray::vtkVoidArray | ( |  | ) |
| protected

## ◆ ~vtkVoidArray()

vtkVoidArray::~vtkVoidArray | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkVoidArray* vtkVoidArray::New | ( |  | ) |
| static

Initialize with empty array.

## ◆ ExtendedNew()

static vtkVoidArray* vtkVoidArray::ExtendedNew | ( |  | ) |
| static

## ◆ IsTypeOf()

static vtkTypeBool vtkVoidArray::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkVoidArray::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkObjectBase.

## ◆ SafeDownCast()

static vtkVoidArray* vtkVoidArray::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkVoidArray::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

## ◆ NewInstance()

vtkVoidArray* vtkVoidArray::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkVoidArray::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkObject.

## ◆ Allocate()

vtkTypeBool vtkVoidArray::Allocate | ( | vtkIdType | sz,
|  | vtkIdType | ext = `1000`
| ) |  |

Allocate memory for this array.

Delete old storage only if necessary. Note that the parameter ext is no longer used.

## ◆ Initialize()

void vtkVoidArray::Initialize | ( |  | ) |

Release storage and reset array to initial state.

## ◆ GetDataType()

int vtkVoidArray::GetDataType | ( |  | ) | const
| inline

Return the type of data.

Definition at line 45 of file vtkVoidArray.h.

## ◆ GetDataTypeSize()

int vtkVoidArray::GetDataTypeSize | ( |  | ) |
| inline

Return the size of the data contained in the array.

Definition at line 50 of file vtkVoidArray.h.

## ◆ SetNumberOfPointers()

void vtkVoidArray::SetNumberOfPointers | ( | vtkIdType | number | ) |
| inline

Set the number of void* pointers held in the array.

Definition at line 55 of file vtkVoidArray.h.

## ◆ GetNumberOfPointers()

vtkIdType vtkVoidArray::GetNumberOfPointers | ( |  | ) |
| inline

Get the number of void* pointers held in the array.

Definition at line 64 of file vtkVoidArray.h.

## ◆ GetVoidPointer()

void* vtkVoidArray::GetVoidPointer | ( | vtkIdType | id | ) |
| inline

Get the void* pointer at the ith location.

Definition at line 69 of file vtkVoidArray.h.

## ◆ SetVoidPointer()

void vtkVoidArray::SetVoidPointer | ( | vtkIdType | id,
|  | void * | ptr
| ) |  |
| inline

Set the void* pointer value at the ith location in the array.

Definition at line 74 of file vtkVoidArray.h.

## ◆ InsertVoidPointer()

void vtkVoidArray::InsertVoidPointer | ( | vtkIdType | i,
|  | void * | ptr
| ) |  |

Insert (memory allocation performed) the void* into the ith location in the array.

## ◆ InsertNextVoidPointer()

vtkIdType vtkVoidArray::InsertNextVoidPointer | ( | void * | tuple | ) |

Insert (memory allocation performed) the void* pointer at the end of the array.

## ◆ Reset()

void vtkVoidArray::Reset | ( |  | ) |
| inline

Reuse already allocated data; make the container look like it is empty.

Definition at line 92 of file vtkVoidArray.h.

## ◆ Squeeze()

void vtkVoidArray::Squeeze | ( |  | ) |
| inline

Resize the array to just fit the inserted memory.

Reclaims extra memory.

Definition at line 97 of file vtkVoidArray.h.

## ◆ GetPointer()

void** vtkVoidArray::GetPointer | ( | vtkIdType | id | ) |
| inline

Get the address of a particular data index.

Performs no checks to verify that the memory has been allocated etc.

Definition at line 103 of file vtkVoidArray.h.

## ◆ WritePointer()

void** vtkVoidArray::WritePointer | ( | vtkIdType | id,
|  | vtkIdType | number
| ) |  |

Get the address of a particular data index.

Make sure data is allocated for the number of items requested. Set NumberOfPointers according to the number of data values requested.

## ◆ DeepCopy()

void vtkVoidArray::DeepCopy | ( | vtkVoidArray * | va | ) |

Deep copy of another void array.

## ◆ ResizeAndExtend()

void** vtkVoidArray::ResizeAndExtend | ( | vtkIdType | sz | ) |
| protected

## Member Data Documentation

## ◆ NumberOfPointers

vtkIdType vtkVoidArray::NumberOfPointers
| protected

Definition at line 121 of file vtkVoidArray.h.

## ◆ Size

vtkIdType vtkVoidArray::Size
| protected

Definition at line 122 of file vtkVoidArray.h.

## ◆ Array

void** vtkVoidArray::Array
| protected

Definition at line 123 of file vtkVoidArray.h.

The documentation for this class was generated from the following file:

- Common/Core/vtkVoidArray.h